program ThreadedCopy;

{$APPTYPE CONSOLE}

uses
  FileReaderAndWriterThreads in 'FileReaderAndWriterThreads.pas',
  Semaphore in 'Semaphore.pas';

var
  readthrd  : TReaderThread;
  writethrd : TWriterThread;
  readsem   : TPosixSemaphore;
  writesem  : TPosixSemaphore;

begin
  if ParamCount < 2 then
  begin
    writeln('ThreadedCopy: file1 file2');
    Exit;
  end;

  // Create our semaphores..
  // the read semaphore starts out with NUMBUFFERS slots available
  readsem := TPosixSemaphore.Create(NUMBUFFERS);
  // the write semaphore starts out with zero buffers available.
  writesem := TPosixSemaphore.Create(0);

  readthrd := TReaderThread.Create(true);
  readthrd.Filename := ParamStr(1);
  readthrd.ReadSemaphore := readsem;
  readthrd.WriteSemaphore := writesem;

  writethrd := TWriterThread.Create(true);
  writethrd.Filename := ParamStr(2);
  writethrd.ReadSemaphore := readsem;
  writethrd.WriteSemaphore := writesem;

  // start the threads..
  readthrd.Resume;
  writethrd.Resume;

  // wait for them
  readthrd.WaitFor;
  writethrd.WaitFor;

  writeln('Done with ThreadedCopy');
end.
