program addmessage;

uses
  SysUtils,
  SysVMsgQueue;

const
  MQ_PATH_NAME = '/tmp/msg1';
  MAX_CHARS    = 80;

type
   TMyMsgQueueRecord = packed record
     MessageType : integer;
     MyInteger   : integer;
     MyFloat     : double;
     MyCharStr   : array[0..MAX_CHARS] of char;
   end;

var
   msg : TSystemVMQ;
   buf : TMyMsgQueueRecord;

begin
   writeln('Adding a message');
   msg              := TSystemVMQ.Create;

   writeln('Setting properties..');
   msg.Debug        := true;
   msg.PrivateKey   := false;
   msg.PathName     := MQ_PATH_NAME;
   msg.Permissions  := [fpOwnerRead, fpOwnerWrite, fpGroupRead, fpGroupWrite];
   msg.OpenExisting := false;  // create it if necessary
   msg.BlockOnWrite := true;
   writeln('Opening the msg queue..');
   msg.Open;

   // build the "message"
   buf.MessageType := 1;
   buf.MyInteger   := 7;
   buf.MyFloat     := 1734.58;
   StrPCopy(buf.MyCharStr,'This is my message to say hello from addmessage');

   writeln('Sending the message..');
   if not msg.Write(@buf, sizeof(TMyMsgQueueRecord) - sizeof(integer)) then
      writeln('error writing message!')
   else
      writeln('message sent!');

   //msg.Close;
   msg.Free;
end.